Index: codes/icosagcm/devel/Python/test/py/RSW_2D.py
===================================================================
--- codes/icosagcm/devel/Python/test/py/RSW_2D.py	(revision 622)
+++ codes/icosagcm/devel/Python/test/py/RSW_2D.py	(revision 631)
@@ -1,2 +1,3 @@
+from dynamico.meshes import Cartesian_mesh as Mesh
 from dynamico import unstructured as unst
 from dynamico import dyn
@@ -15,5 +16,5 @@
 
 unst.setvar('g',g)
-mesh = unst.Cartesian_mesh(nx,ny,llm,nqdyn,Lx,Ly,f)
+mesh = Mesh(nx,ny,llm,nqdyn,Lx,Ly,f)
 caldyn = unst.Caldyn_RSW(mesh)
 
Index: codes/icosagcm/devel/Python/test/py/RSW_MPAS_W02.py
===================================================================
--- codes/icosagcm/devel/Python/test/py/RSW_MPAS_W02.py	(revision 622)
+++ codes/icosagcm/devel/Python/test/py/RSW_MPAS_W02.py	(revision 631)
@@ -1,19 +1,13 @@
-import sys
 print 'Loading modules ...'
-sys.stdout.flush()
-
 import math as math
-# select non-interactive backend, cf http://stackoverflow.com/questions/4931376/generating-matplotlib-graphs-without-a-running-x-server
-import matplotlib
-matplotlib.use('Agg') 
 import matplotlib.pyplot as plt
 import numpy as np
+print '...Done'
 
 print 'Loading DYNAMICO modules ...'
-sys.stdout.flush()
 from dynamico import unstructured as unst
+from dynamico.meshes import MPAS_Mesh as Mesh
 from dynamico import time_step
 print '...Done'
-sys.stdout.flush()
 
 grid, llm, nqdyn = 10242, 1,1 # 2562, 10242, 40962
@@ -22,12 +16,9 @@
 
 print 'Omega, planetary PV', Omega, 2*Omega/gh0
-sys.stdout.flush()
 
 def f(lon,lat): return 2*Omega*np.sin(lat) # Coriolis parameter
 print 'Reading MPAS mesh ...'
-sys.stdout.flush()
-mesh = unst.MPAS_Mesh('grids/x1.%d.grid.nc'%grid, llm, nqdyn, radius, f)
+mesh = Mesh('grids/x1.%d.grid.nc'%grid, llm, nqdyn, radius, f)
 print '...Done'
-sys.stdout.flush()
 lon, lat = mesh.lon_i, mesh.lat_i
 x,y,z = np.cos(lat)*np.cos(lon), np.cos(lat)*np.sin(lon), np.sin(lat)
Index: codes/icosagcm/devel/Python/test/py/bubble.py
===================================================================
--- codes/icosagcm/devel/Python/test/py/bubble.py	(revision 622)
+++ codes/icosagcm/devel/Python/test/py/bubble.py	(revision 631)
@@ -4,4 +4,5 @@
 import matplotlib.animation as manimation
 
+from dynamico.meshes import Cartesian_mesh as Mesh
 import dynamico.dyn as dyn
 import dynamico.time_step as time_step
@@ -94,5 +95,5 @@
 
 unst.setvar('nb_threads', 1)
-mesh = unst.Cartesian_mesh(nx,ny,llm,nqdyn,Lx,ny*dx,0.)
+mesh = Mesh(nx,ny,llm,nqdyn,Lx,ny*dx,0.)
 xx_ik, xx_il, ll = mesh.xx[:,0,:]/1000, mesh.xxp1[:,0,:]/1000, mesh.ll[:,0,:]
 
Index: codes/icosagcm/devel/Python/test/py/slice_GW_NH.py
===================================================================
--- codes/icosagcm/devel/Python/test/py/slice_GW_NH.py	(revision 622)
+++ codes/icosagcm/devel/Python/test/py/slice_GW_NH.py	(revision 631)
@@ -1,2 +1,3 @@
+from dynamico.meshes import Cartesian_mesh as Mesh
 from dynamico import unstructured as unst
 from dynamico import dyn
@@ -91,5 +92,5 @@
 Lx, nx, ztop, llm = 2e5, 400, 3e4, 60
 nqdyn, ny, dx = 1, 1, Lx/nx
-mesh = unst.Cartesian_mesh(nx,ny,llm,nqdyn,nx*dx,ny*dx,0.)
+mesh = Mesh(nx,ny,llm,nqdyn,nx*dx,ny*dx,0.)
 xx,ll = mesh.xx[:,0,:]/1000, mesh.ll[:,0,:]
 
Index: codes/icosagcm/devel/Python/test/py/slice_GW_hydro.py
===================================================================
--- codes/icosagcm/devel/Python/test/py/slice_GW_hydro.py	(revision 622)
+++ codes/icosagcm/devel/Python/test/py/slice_GW_hydro.py	(revision 631)
@@ -1,2 +1,3 @@
+from dynamico.meshes import Cartesian_mesh as Mesh
 from dynamico import unstructured as unst
 from dynamico import dyn
@@ -58,5 +59,5 @@
 Lx, nx, llm = 3e5, 300, 20
 nqdyn, ny, dx = 1, 1, Lx/nx
-mesh = unst.Cartesian_mesh(nx,ny,llm,nqdyn,nx*dx,ny*dx,0.)
+mesh = Mesh(nx,ny,llm,nqdyn,nx*dx,ny*dx,0.)
 xx,ll = mesh.xx[:,0,:]/1000, mesh.ll[:,0,:]
 metric, thermo, BC, m0ik, gas0, Phi0_il, u0_jk = DCMIP.DCMIP31(Lx, nx, llm)
Index: codes/icosagcm/devel/Python/test/py/test_xios.py
===================================================================
--- codes/icosagcm/devel/Python/test/py/test_xios.py	(revision 622)
+++ codes/icosagcm/devel/Python/test/py/test_xios.py	(revision 631)
@@ -4,7 +4,5 @@
 print '%d/%d starting'%(mpi_rank,mpi_size)
 
-import sys
 import numpy as np
-#import dynamico.wrap as wrap
 print 'import dynamico.unstructured'
 import dynamico.unstructured as unst
@@ -12,4 +10,5 @@
 import dynamico.xios as xios
 print 'Done.'
+from dynamico.meshes import MPAS_Mesh as Mesh, radian
 
 def boundaries(degree,points,lon,lat):
@@ -29,17 +28,13 @@
 #----------------------------- read MPAS mesh --------------------------------
 
-radian=unst.radian
 grid, llm, nqdyn, nqtot = 10242, 1,1,1 # 2562, 10242, 40962  
 Omega, radius, g, gh0 = 2.*np.pi/86400., 6.4e6, 1., 2.94e4
 N, T, courant = 40, 10800., 1.2 # simulation length = N*T
 print 'Omega, planetary PV', Omega, 2*Omega/gh0
-sys.stdout.flush()
 
 def f(lon,lat): return 2*Omega*np.sin(lat) # Coriolis parameter                                                                                                                
 print 'Reading MPAS mesh ...'
-sys.stdout.flush()
-mesh = unst.MPAS_Mesh('grids/x1.%d.grid.nc'%grid, llm, nqdyn, radius, f)
+mesh = Mesh('grids/x1.%d.grid.nc'%grid, llm, nqdyn, radius, f)
 print '...Done'
-sys.stdout.flush()
 
 lon_i, lat_i, lon_v, lat_v = [x*radian for x in mesh.lon_i, mesh.lat_i, mesh.lon_v, mesh.lat_v]