Index: codes/icosagcm/devel/src/unstructured/caldyn_unstructured.F90
===================================================================
--- codes/icosagcm/devel/src/unstructured/caldyn_unstructured.F90	(revision 644)
+++ codes/icosagcm/devel/src/unstructured/caldyn_unstructured.F90	(revision 645)
@@ -107,4 +107,5 @@
   DBL :: dF_deta, dFu_deta
   wwuu=0.
+  !$OMP BARRIER
 #include "../kernels_unst/caldyn_wflux.k90"
 #include "../kernels_unst/caldyn_dmass.k90"
@@ -112,5 +113,5 @@
 END SUBROUTINE caldyn_vert
 
-SUBROUTINE compute_coriolis(hflux,theta,qu, convm,dtheta_rhodz,du)
+SUBROUTINE compute_coriolis(hflux,theta,qu,Ftheta, convm,dtheta_rhodz,du)
   FIELD_U     :: hflux, Ftheta, qu, du
   FIELD_MASS  :: convm
Index: codes/icosagcm/devel/src/unstructured/timestep_unstructured.F90
===================================================================
--- codes/icosagcm/devel/src/unstructured/timestep_unstructured.F90	(revision 644)
+++ codes/icosagcm/devel/src/unstructured/timestep_unstructured.F90	(revision 645)
@@ -41,11 +41,11 @@
                                  dPhi_fast, dPhi_slow, dW_fast, dW_slow) BINDC(caldyn_unstructured) ! OUT : tendencies
     DBL, VALUE :: tau
-    FIELD_MASS   :: rhodz, drhodz, pk, berni         ! IN, OUT, DIAG
-    FIELD_THETA  :: theta_rhodz, dtheta_rhodz, theta ! IN, OUT, DIAG
-    FIELD_GEOPOT :: wflux, w, geopot, &              ! DIAG, INOUT
-         dPhi_fast, dPhi_slow, dW_fast, dW_slow      ! OUT
-    FIELD_U      :: u,du_fast,du_slow,hflux,qu       ! INOUT,OUT,OUT,DIAG
-    FIELD_Z      :: qv                               ! DIAG
-    FIELD_PS     :: ps,dmass_col,mass_col            ! OUT,OUT,IN (if eta_mass) or OUT,UNUSED,UNUSED (if eta_lag)
+    FIELD_MASS   :: rhodz, drhodz, pk, berni          ! IN, OUT, DIAG
+    FIELD_THETA  :: theta_rhodz, dtheta_rhodz, theta  ! IN, OUT, DIAG
+    FIELD_GEOPOT :: wflux, w, geopot, &               ! DIAG, INOUT
+         dPhi_fast, dPhi_slow, dW_fast, dW_slow       ! OUT
+    FIELD_U      :: u,du_fast,du_slow,hflux,Ftheta,qu ! INOUT,OUT,OUT,DIAG
+    FIELD_Z      :: qv                                ! DIAG
+    FIELD_PS     :: ps,dmass_col,mass_col             ! OUT,OUT,IN (if eta_mass) or OUT,UNUSED,UNUSED (if eta_lag)
     FIELD_UL     :: wwuu
     DBL          :: time1,time2
@@ -71,5 +71,5 @@
        CALL compute_pvort_only(rhodz,u,qv,qu)
        CALL compute_caldyn_slow_hydro(rhodz,theta,u, berni,hflux,du_slow)
-       CALL compute_coriolis(hflux,theta,qu, drhodz,dtheta_rhodz,du_slow)
+       CALL compute_coriolis(hflux,theta,qu,Ftheta, drhodz,dtheta_rhodz,du_slow)
        IF(caldyn_eta == eta_mass) THEN
           CALL caldyn_vert(drhodz,rhodz,theta,u, dmass_col,wflux,dtheta_rhodz,du_slow,wwuu)
@@ -91,5 +91,5 @@
        CALL compute_pvort_only(rhodz,u,qv,qu)
        CALL compute_caldyn_slow_NH(u,rhodz,geopot,W, hflux,du_slow,dPhi_slow,dW_slow) 
-       CALL compute_coriolis(hflux,theta,qu, drhodz,dtheta_rhodz,du_slow)
+       CALL compute_coriolis(hflux,theta,qu,Ftheta, drhodz,dtheta_rhodz,du_slow)
        IF(caldyn_eta == eta_mass) THEN
           CALL caldyn_vert(drhodz,rhodz,theta,u, dmass_col,wflux,dtheta_rhodz,du_slow,wwuu)
@@ -114,5 +114,5 @@
     FIELD_MASS   :: rhodz, pk, berni                 ! IN, DIAG
     FIELD_THETA  :: theta_rhodz, theta               ! IN, DIAG
-    FIELD_U      :: u,hflux,qu                       ! INOUT,DIAG
+    FIELD_U      :: u,hflux,qu,Ftheta                ! INOUT,DIAG*3
     FIELD_GEOPOT :: geopot, w, wflux, w_il           ! IN, INOUT, DIAG, DIAG
     FIELD_Z      :: qv                               ! DIAG
@@ -150,5 +150,5 @@
              CALL compute_pvort_only(rhodz,u,qv,qu)
              CALL compute_caldyn_slow_hydro(rhodz,theta,u, berni,hflux,du_slow(:,:,stage))
-             CALL compute_coriolis(hflux,theta,qu, drhodz(:,:,stage), dtheta_rhodz(:,:,:,stage),du_slow(:,:,stage))
+             CALL compute_coriolis(hflux,theta,qu,Ftheta, drhodz(:,:,stage), dtheta_rhodz(:,:,:,stage),du_slow(:,:,stage))
              IF(caldyn_eta == eta_mass) THEN
                 CALL caldyn_vert(drhodz(:,:,stage),rhodz,theta,u, &
@@ -169,5 +169,5 @@
              CALL compute_pvort_only(rhodz,u,qv,qu)
              CALL compute_caldyn_slow_NH(u,rhodz,geopot,W, hflux, du_slow(:,:,stage), dPhi_slow(:,:,stage), dW_slow(:,:,stage))
-             CALL compute_coriolis(hflux,theta,qu, drhodz(:,:,stage),dtheta_rhodz(:,:,:,stage), du_slow(:,:,stage))
+             CALL compute_coriolis(hflux,theta,qu,Ftheta, drhodz(:,:,stage),dtheta_rhodz(:,:,:,stage), du_slow(:,:,stage))
              IF(caldyn_eta == eta_mass) THEN
                 CALL caldyn_vert(drhodz(:,:,stage),rhodz,theta,u, &